' *** CODE 15.2: Einfacher Netzwerk-Client

#INCLUDE "TSNE_V3.bi"

SUB Verbunden(BYVAL id AS UINTEGER)
  PRINT "Die Verbindung wurde hergestellt."
END SUB
SUB Getrennt(BYVAL id AS UINTEGER)
  PRINT "Die Verbindung wurde getrennt."
END SUB
SUB NeueDaten(BYVAL id AS UINTEGER, BYREF daten AS STRING)
  PRINT "Neue Daten von Client " & id & ": " & daten
END SUB
 
' Client erstellen
DIM bv as INTEGER, Client AS UINTEGER, host AS STRING = "127.0.0.1"
bv = TSNE_Create_Client(Client, host, 1100, @Getrennt, @Verbunden, @NeueDaten)
IF bv <> TSNE_Const_NoError THEN PRINT "Server-Fehler: " & BV : END
bv = TSNE_WaitConnected(Client)           ' auf Verbindung warten
IF bv <> TSNE_Const_NoError THEN PRINT "Fehler: " & TSNE_GetGURUCode(BV) : END
TSNE_Data_Send 1, "Hallo Server!"         ' Daten senden
TSNE_Disconnect(Client)                   ' Client beenden
TSNE_WaitClose(Client)                    ' warten bis Client beendet ist