' *** CODE 16.2: Rckgabewerte eines Lua-Skripts

' **********************
' * FreeBASIC-Programm *
' **********************
#include once "Lua/lua.bi"
#include once "Lua/lauxlib.bi"
#include once "Lua/lualib.bi"

' Lua bereitstellen
dim Lua as lua_State ptr
Lua = luaL_newstate

' Skript aufrufen
if luaL_dofile(Lua, "rueckgabe.lua") then
  print "Skriptfehler: " & *lua_tostring(Lua, -1) 
end if

'Auswertung
for i as integer = 1 to lua_gettop(Lua)  ' alle Parameter auswerten
  if lua_isNumber(Lua, i) then           ' Zahlenwert
    print lua_toNumber(Lua, i),
  elseif lua_isString(Lua, i) then       ' String (ZSTRING PTR)
    print *lua_toString(Lua, i),
  elseif lua_isboolean(Lua, i) then      ' Wahrheitswert (true/false)
    if lua_toBoolean(Lua, i) then print "true", else print "false",
  else
    print "unbekannt",
  end if
next
lua_close Lua                             ' Lua-Status freigeben
getkey



' **********************
' *     Lua-Script     *
' **********************
x = "Adieu"
return 3.14, 1+2 == 3, x
